100 REMark *** SKI RUN ***
110 REMark by Trevor Toms for ZX81
120 REMark converted to QL by Dilwyn Jones 2023
130 :
140 WINDOW 260,252,30,2 : PAPER 7 : INK 0 : CSIZE 1,0 : BORDER 1,4
150 :
160 slowdown = 200000 : REMark 0=full speed, 200000=QPC2 on fast PC
170 RANDOMISE
180 :
190 REPeat game
200   REMark initialise game
210   Show_Rules
220   :
230   post = course$(1 TO 2) : REMark course start position
240   old_post = post        : REMark for skier position (one line up)
250   ski = course$(3 TO 4)  : REMark skier start position
260   hits = 0               : REMark initialise hits counter
270   CLS : PRINT'COURSE:';course_no;'  SKILL:';skill;'  HITS:0';
280   :
290   REMark run the course
300   speed_count = 0 : REMark used for slowdown on fast systems
310   FOR x = 5 TO LEN(course$)-1 STEP 2
320     AT 0,0 : SCROLL -10,2
330     AT 24,post : PRINT '*';                : REMark left hand post
340     AT 24,post+course_width : PRINT '*';   : REMark right hand post
350     AT 23,ski : INK 2 : PRINT 'V'; : INK 0 : REMark skier
360     :
370     Check_For_Movement : REMark check cursor keys
380     :
390     speed_count = 0
400     REPeat control_speed
410       speed_count = speed_count + 1
420       IF speed_count = slowdown THEN EXIT control_speed
430     END REPeat control_speed
440     :
450     old_post = post
460     post = post + (course$(x TO x+1)) : REMark update post position
470     :
480     Check_For_Movement : REMark another quick movement check
490     :
500     IF ski = old_post OR ski = old_post+course_width THEN
510       BEEP 1000,20 : hits = hits + 1 : REMark hit a post
520     ELSE
530       IF ski < old_post OR ski > old_post+course_width THEN
540         BEEP 20,0 : hits = hits + 1 : REMark skier outside course
550       END IF
560     END IF
570     AT 0,24: PRINT hits
580   END FOR x
590   :
600   REMark finishing line
610   AT 24,ski : INK 2 : PRINT 'V'; : INK 0 : REMark finish position
620   AT 0,0 : SCROLL -10,2
630   PAPER 0 : INK 7
640   AT 24,post : PRINT '+'&FILL$('-',course_width-1);'+';
650   PAPER 7 : INK 0
660   AT 0,0 : SCROLL -20,2
670   AT 24,0 : INPUT 'ANOTHER GAME Y/N ';yn$
680   IF NOT(yn$=='y') THEN EXIT game
690 END REPeat game
700 STOP
710 :
720 DEFine PROCedure Select_Course
730   REMark course$(1 TO 2) = starting position on screen of left hand post
740   REMark course$(3 TO 4) = starting position of skier
750   REMark course$(5 TO)   = 2-digit numeric values which represent the
760   REMark                   value t to add into the current post position
770   REMark                   to give the next position
780   IF RND < .5 THEN
790     course_no = 1
800     course$='141700000000-1-1-1-1-100000001010200-1-1-100010200-200-1-1-100000000010101010101-2-2-2000000000101010101010101020202000000000000-1-1-1010101-1-1-1-1-1-2-2-2-2-2-1-1000000010101010101-2-2-2-20000000101020202020101010000000000000000'
810   ELSE
820     course_no = 2
830     course$='00020000000000000000000000000101010101010101010100000000020202020000-1-1-1-1-1-1-1-1010101010000000000000000-1-1-1-102020202010101-2-2-2-2-2-2-2-1-1-1-1-10101-1-1000000000000'
840   END IF
850   PRINT 'SKIING COURSE #';course_no
860 END DEFine Select_Course
870 :
880 DEFine PROCedure Show_Rules
890   CLS
900   REMark SLOW
910   PRINT TO 8;'*** SKI RUN ***'
920   PRINT ' YOU MUST STAY IN BETWEEN THE'\'COURSE POSTS ALL THE WAY DOWN.'
930   PRINT ' IF YOU HIT THE POSTS OR MOVE'\'OUTSIDE THE COURSE, YOU WILL'\'LOSE POINTS.'
940   PRINT' YOU MAY INITIALLY SELECT THE'\'DIFFICULTY OF COURSE YOU WISH'\'TO ATTEMPT.'
950   PRINT' USE THE ';CHR$(188);' AND ';CHR$(189);' KEYS TO'\'DIRECT YOURSELF LEFT AND RIGHT.'
960   PRINT
970   REPeat enter_skill
980     PRINT'WHICH LEVEL ARE YOU?'\' (1) RANK AMATEUR'\' (2) AVERAGE SKIER'\' (3) DASHING EXPERT?'
990     INPUT skill
1000     IF skill > 0 AND skill < 4 THEN EXIT enter_skill
1010     CLS
1020     PRINT'SORRY? - ';
1030   END REPeat enter_skill
1040   :
1050   course_width = 3+(4-skill)*2 : REMark course width
1060   Select_Course
1070   PRINT'ARE YOU READY? - ';
1080   FOR x = 3 TO 1 STEP -1
1090     PRINT x;'..';
1100     PAUSE 50
1110   END FOR x
1120   PRINT
1130 END DEFine Show_Rules
1140 :
1150 DEFine PROCedure Check_For_Movement
1160   REMark check cursor left and right keys with KEYROW
1170   d = KEYROW(1)
1180   ski = ski - ((d&&2)<>0 AND ski>0) + ((d&&16)<>0 AND ski<31)
1190 END DEFine Check_For_Movement
1200 :
1210 DEFine PROCedure XTV
1220   OUTLN #0,FLIM_W(#0),FLIM_H(#0),0,0
1230   WINDOW FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #2,FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #0,FLIM_W(#0),52,0,FLIM_H(#0)-52
1240   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
1250   CLS : CLS #2 : CLS #0
1260 END DEFine XTV
1270 :
